/*	Hardware definitions for graphic LCD displays
	
		PA.8,9,11-15	I/O	LCD D0,1,3-7
		PB11		I/O	LCD D2
	
		PB.13	Out	LCD RD
		PB.14	Out	LCD WR
		PB.12	Out	LCD A0
		PB.15	Out	LCD CS
*/

/* LCD control signals */
#define	LCD_RDb	13
#define	LCD_A0b	12
#define	LCD_WRb	14
#define	LCD_CSb	15
#define LCD_D2b	11

// Bit-band alias = Bit-band base + (byte offset * 32) + (bit number * 4)
/* Bit-Band for Device Specific Peripheral Registers */
#define BITBAND_PERI(addr, bitnum) (HT_PERIPH_BB_BASE + (((uint32_t)(addr) - HT_PERIPH_BASE) << 5) + ((uint32_t)(bitnum) << 2))

#define	LCD_RD	(*((__IO uint32_t *)BITBAND_PERI(&HT_GPIOB->DOUTR,LCD_RDb)))
#define	LCD_A0	(*((__IO uint32_t *)BITBAND_PERI(&HT_GPIOB->DOUTR,LCD_A0b)))
#define	LCD_WR	(*((__IO uint32_t *)BITBAND_PERI(&HT_GPIOB->DOUTR,LCD_WRb)))
#define	LCD_CS	(*((__IO uint32_t *)BITBAND_PERI(&HT_GPIOB->DOUTR,LCD_CSb)))

/* Low level functions */
void LCD_Write(unsigned char dat);
unsigned char LCD_Read(void);
void LCD_setupIO(void);
