#include <HT32F125x.h>                    // 

/* Fijarse en Project -> Options -> C/C++ Compiler -> Preprocessor
los paths para agregar el CMSIS y que el IAR lo incluya 
est en $TOOLKIT_DIR$/CMSIS porque yo (SRC) lo puse ahi */

#include <math.h>
#define m_PI 3.14159265358979323846264338327

#include "SED1335.h"

//#include "goku.h"
#include "cika.h"
#include "cikas.h"
#include "pdm.h"
#include "arm.h"
#include "holtek.h"

volatile unsigned long SysTickCnt;      // SysTick Counter

// SysTick Setup
void SysTick_Setup (void)
{
  SysTick->LOAD = 72000 - 1;            // 1ms: 72000 ticks @ 72MHz
  SysTick->CTRL = 0x0007;               // Enable Counter and Tick Interrupt
}

// SysTick Interrupt Handler (tick each 1ms)
void SysTick_Handler (void)
{
  SysTickCnt++;
}


// Delay Function
void Delay (unsigned long tick)
{
unsigned long systickcnt;

  systickcnt = SysTickCnt;
  while ((SysTickCnt - systickcnt) < tick);
}
#define MsDelay Delay


main()
{
unsigned int addr;
int i,dy,py,ny;
unsigned int yl, yh;

	SysTick_Setup();
	LCD_init();
	while(1){
		LCD_cleartxt();
		LCD_cleargfx();
								// address gfx screen
		LCD_fill(1200,40,240,0xFF);					// black fill
		MsDelay ( 1000 );						// wait 1 sec
		LCD_cleargfx();
		MsDelay ( 1000 );						// wait 1 sec

		for(i=0;i<320;i++)
			LCD_plot(i,120); 					// x axis
		for(i=0;i<240;i++)
			LCD_plot(160,i); 					// y axis
		for(i=-160;i<159;i++)
			LCD_plot(160+i,120-(int)(120*(cosf(i*m_PI/160)))); // plot cos(x); 0,0 is at top left
		LCD_printat(0,0,"cos(x)");
		MsDelay ( 3000 );						// wait 3 secs

		LCD_cleartxt();
		LCD_cleargfx();
		LCD_line(0,120,319,120);
		LCD_line(160,0,160,239);
		LCD_icon(1200+0,152/8,119,(uint8_t *)holtek);
		LCD_icon(1200+21+0,144/8,119,(uint8_t *)arm);
		LCD_icon(1200+40*150,152/8,61,(uint8_t *)pdm);
		LCD_icon(1200+21+40*144,152/8,78,(uint8_t *)cikas);
		LCD_rectangle(0,0,319,239);
		MsDelay ( 6000 );						// wait 3 secs
#if 0
		LCD_cleargfx();
		LCD_dump((uint8_t *)goku);						// show gfx
		LCD_printat(0,0,"Texto y graficos");
		LCD_printat(1,2,"superpuestos");
		LCD_fill(1200+8*40+2,12,8,0xFF);				// invert
		MsDelay ( 5000 );						// wait 3 secs
#endif
		LCD_cleargfx();
		LCD_cleartxt();
		LCD_font=0;
		LCD_printat(0,0,"5x7 standard incluida en el display");
		LCD_printFat(2,0,"8x8 generada como graficos");
		LCD_font=1;
		LCD_printFat(4,0,"8x15 generada como graficos");
		MsDelay ( 5000 );						// wait 3 secs

		LCD_cleartxt();
		LCD_cleargfx();
		LCD_printat(12,9,"Cika Electronica S.R.L.");
		LCD_printat(15,9,"Master distribuidor de");
		LCD_printat(18,8,"componentes electronicos");
		yl =  0;
		yh = 95;
		ny = 50;
   		dy = 1;
		i=500;
		py=ny;

		while(i--){
		    addr=1200+(py<<5)+(py<<3);                       // 1200 + py*40
		    LCD_fill(addr,40,142,0);
	   	    py = ny;
		    addr=1200+(py<<5)+(py<<3);                       // 1200 + py*40
		    LCD_icon(addr,40,142,(uint8_t *)cika);
		    MsDelay(50);
 	   	    ny = py + dy;
		    if (ny < yl || ny > yh) {
				dy = -dy;
				ny = py + dy;
		    }
		}

	}
}
